///*   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *///
///* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *///
///*************************************************************************///
///**                      Y.     P.     G.     E.                        **///
///*   YARSOFT PLATFORM GAME ENGINE.  DEVELOPED BY YARSOFT USING ALLEGRO   *///
///**                                                                     **///
///*************************************************************************///
///* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *///
///*   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *   *///

/* Including iostream for compatibility and allegro.h to use allegro */

#include <iostream>
#include <allegro.h>

/* Defining a character to interger function which will be used quite often */
/* when intializing the values of practically every sprite and background   */
/* object and class in this entire engine.This can only be used for numbers */
int char_int(char inchar)   /* The function prototype and definition */
{
	int int_char;
	if( inchar == '0')
	{
		int_char = 0;
		return int_char;
	}
	if( inchar == '1')
	{
		int_char = 1;
		return int_char;
	}
	if( inchar == '2')
	{
		int_char = 2;
		return int_char;
	}
	if( inchar == '3')
	{
		int_char = 3;
		return int_char;	}
	if( inchar == '4')
	{
		int_char = 4;
		return int_char;
	}
	if( inchar == '5')
	{
		int_char = 5;
		return int_char;
	}
	if( inchar == '6')
	{
		int_char = 6;
		return int_char;
	}
	if( inchar == '7')
	{
		int_char = 7;
		return int_char;
	}
	if( inchar == '8')
	{
		int_char = 8;
		return int_char;
	}
	if( inchar == '9')
	{
		int_char = 9;
		return int_char;
	}
}

/*  Loading up the file structures needed when loading text files.         */

FILE *stream;    /*  What links us to the file itself */
int  ch;         /*  Takes the original integer values from the file */
char bad_int;    /*  "Bad" numbers, which are in char form and need to be converted */

/* Random image necessities */
PALETTE pal;
BITMAP *temp;
BITMAP *newscreen, *layer1, *layer2, *layer3;
BITMAP *bg1, *bg2, *bg3, *bg4;
int use, use1, use2, olduse;
int drawcounter = 0; 
int drawcounter2 = 0;
MIDI *song;

/*****Speed Class, which includes, speed, acceleration, and decceleration*****/

class SPEED
{
public:
	int acceleration;
	int decceleration;
	int setspeed;
	int speed;
	int topspeed;
	int acccount;
	int deccount;
SPEED(int ACC, int DCC, int STPD,int SPD, int TSPD)
{
	acceleration = ACC;
	decceleration = DCC;
	setspeed = STPD;
	speed = SPD;
	topspeed = TSPD;
	acccount = 0;
	deccount = 0;
}
};
/* Defining a sprite class which includes all the neccessities of a sprite */

class SPRITE
{
public:
	int Lcol;
	int Rcol;
	int Ucol;
	int Dcol;
	char sif[25];               /*       Name of the .sif file for data     */
//	char saf[25];               /*   Name of the .saf file for data action  */
	char bmp[25];               /*  Name of the .bmp file for picture data  */
	int xpos;                   /*           X position on the map          */
	int ypos;                   /*           Y position on the map          */
	int lcxstart;               /*   X Start of the level collision box     */
	int lcystart;               /*   Y Start of the level collision box     */  
	int lcxend;                 /*    Width for level collision detection   */
	int lcyend;                 /*   Height for level collision detection   */
	int *xhurt;					/*     X starting point for damage areas    */
	int *yhurt;			        /*     Y starting point for damage areas    */
	int *xhurtend;				/*      X ending point for damage areas     */
	int *yhurtend;				/*      Y ending point for damage areas     */
	int *xattack;				/*     X starting point for attack areas    */
	int *yattack;				/*     Y starting point for attack areas    */
	int *xattackend;			/*      X ending point for attack areas     */
	int *yattackend;			/*      Y ending point for attack areas     */
	int *picxstart;				/* X starting point to pick images from bmp */
	int *picystart;				/* Y starting point to pick images from bmp */
	int *picxend;				/*  X ending point to pick images from bmp  */
	int *picyend;               /*  Y ending point to pick images from bmp  */
	int action;                 /*              Current action              */
	BITMAP *frames;              /*   Our bitmap pointer, used to get tiles  */
	SPRITE(char inname[15], int x, int y)  /*      Start of our sprite constructor     */
	{
		Lcol = 0;
		Rcol = 0;
		Ucol = 0;
		Dcol = 0;
		strcpy(sif, inname);
		strcpy(bmp, inname);
		//strcpy(saf, inname);    /*   Copying the name of the sprite to saf  */
		strcat(sif, ".sif");    /*    Adding the extension ".sif" to sif    */
		//strcat(saf, ".saf");    /*    Adding the extension ".saf" to saf    */
		strcat(bmp, ".bmp");    /*    Adding the extension ".bmp" to bmp    */
		int fourdigit = 0;      /*           A number placeholder           */ 
		int counter = 0;        /*             A simple counter             */
		int fourdigit2 = 0;     /*            Another placeholder           */
		xpos = x;               /*      Setting the initial x position      */
		ypos = y;               /*      Setting the initial y position      */

		stream = fopen( sif, "r" );  /*    Opening the sif file for data    */

/***********     Getting Maximum frames    ************/

		int maxframes = 0;
		bad_int = (ch = fgetc( stream ));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 1000;
		maxframes = maxframes + fourdigit;

		bad_int = (ch = fgetc( stream));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 100;
		maxframes = maxframes + fourdigit;

		bad_int = (ch = fgetc( stream));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 10;
		maxframes = maxframes + fourdigit;

		bad_int = (ch = fgetc( stream));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 1;
		maxframes = maxframes + fourdigit;
/****************END OF EQUATION******************/

/*********** Getting value of lcxstart ************/
		lcxstart = 0;
		bad_int = (ch = fgetc( stream ));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 1000;
		lcxstart = lcxstart + fourdigit;

		bad_int = (ch = fgetc( stream));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 100;
		lcxstart = lcxstart + fourdigit;

		bad_int = (ch = fgetc( stream));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 10;
		lcxstart = lcxstart + fourdigit;

		bad_int = (ch = fgetc( stream));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 1;
		lcxstart = lcxstart + fourdigit;

/**************END OF EQUATION**************/

/*********** Getting value of lcystart ************/
		lcystart = 0;
		bad_int = (ch = fgetc( stream ));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 1000;
		lcystart = lcystart + fourdigit;

		bad_int = (ch = fgetc( stream));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 100;
		lcystart = lcystart + fourdigit;

		bad_int = (ch = fgetc( stream));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 10;
		lcystart = lcystart + fourdigit;

		bad_int = (ch = fgetc( stream));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 1;
		lcystart = lcystart + fourdigit;

/**************END OF EQUATION**************/

/*********** Getting value of lcxend ************/
		lcxend = 0;
		bad_int = (ch = fgetc( stream ));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 1000;
		lcxend = lcxend + fourdigit;

		bad_int = (ch = fgetc( stream));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 100;
		lcxend = lcxend + fourdigit;

		bad_int = (ch = fgetc( stream));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 10;
		lcxend = lcxend + fourdigit;

		bad_int = (ch = fgetc( stream));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 1;
		lcxend = lcxend + fourdigit;

/**************END OF EQUATION**************/

/*********** Getting value of lcystart ************/
		lcyend = 0;
		bad_int = (ch = fgetc( stream ));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 1000;
		lcyend = lcyend + fourdigit;

		bad_int = (ch = fgetc( stream));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 100;
		lcyend = lcyend + fourdigit;

		bad_int = (ch = fgetc( stream));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 10;
		lcyend = lcyend + fourdigit;

		bad_int = (ch = fgetc( stream));
		fourdigit = char_int(bad_int);
		fourdigit = fourdigit * 1;
		lcyend = lcyend + fourdigit;

/**************END OF EQUATION**************/

/*****  Making all the collision boxes *****/

		xhurt = new int[maxframes];
		yhurt = new int[maxframes];
		xhurtend = new int[maxframes];
		yhurtend = new int[maxframes];
		xattack = new int[maxframes];
		yattack = new int[maxframes];
		xattackend = new int[maxframes];
		yattackend = new int[maxframes];
		picxstart = new int[maxframes];
		picystart = new int[maxframes];
		picxend = new int[maxframes];
		picyend = new int[maxframes];

		 while( counter < maxframes )
		{

		/***    Initializing the picxstart array values ***/
			 fourdigit2 = 0;
			bad_int = (ch = fgetc( stream ));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1000;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 100;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 10;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1;
			fourdigit2 = fourdigit2 + fourdigit;
			
			*(picxstart + counter) = fourdigit2;
		/***               END OF EQUATION              ***/

		/***    Initializing the picystart array values ***/
			fourdigit2 = 0;
			bad_int = (ch = fgetc( stream ));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1000;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 100;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 10;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1;
			fourdigit2 = fourdigit2 + fourdigit;
			
			*(picystart + counter) = fourdigit2;
		/***               END OF EQUATION              ***/

		/***    Initializing the picxend array values ***/
			fourdigit2 = 0;
			bad_int = (ch = fgetc( stream ));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1000;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 100;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 10;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1;
			fourdigit2 = fourdigit2 + fourdigit;
			
			*(picxend + counter) = fourdigit2;
		/***               END OF EQUATION              ***/

		/***    Initializing the picyend array values ***/
			fourdigit2 = 0;
			bad_int = (ch = fgetc( stream ));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1000;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 100;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 10;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1;
			fourdigit2 = fourdigit2 + fourdigit;
			
			*(picyend + counter) = fourdigit2;
		/***               END OF EQUATION              ***/

		/***    Initializing the xhurt array values ***/
			fourdigit2 = 0;
			bad_int = (ch = fgetc( stream ));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1000;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 100;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 10;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1;
			fourdigit2 = fourdigit2 + fourdigit;
			
			*(xhurt + counter) = fourdigit2;
		/***               END OF EQUATION              ***/

		/***    Initializing the yhurt array values ***/
			fourdigit2 = 0;
			bad_int = (ch = fgetc( stream ));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1000;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 100;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 10;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1;
			fourdigit2 = fourdigit2 + fourdigit;
			
			*(yhurt + counter) = fourdigit2;
		/***               END OF EQUATION              ***/

		/***    Initializing the xhurtend array values ***/
			fourdigit2 = 0;
			bad_int = (ch = fgetc( stream ));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1000;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 100;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 10;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1;
			fourdigit2 = fourdigit2 + fourdigit;
			
			*(xhurtend + counter) = fourdigit2;
		/***               END OF EQUATION              ***/

		/***    Initializing the yhurtend array values ***/
			fourdigit2 = 0;
			bad_int = (ch = fgetc( stream ));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1000;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 100;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 10;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1;
			fourdigit2 = fourdigit2 + fourdigit;
			
			*(yhurtend + counter) = fourdigit2;
		/***               END OF EQUATION              ***/

		/***    Initializing the xattack array values ***/
			fourdigit2 = 0;
			bad_int = (ch = fgetc( stream ));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1000;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 100;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 10;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1;
			fourdigit2 = fourdigit2 + fourdigit;
			
			*(xattack + counter) = fourdigit2;
		/***               END OF EQUATION              ***/

		/***    Initializing the yattack array values ***/
			fourdigit2 = 0;
			bad_int = (ch = fgetc( stream ));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1000;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 100;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 10;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1;
			fourdigit2 = fourdigit2 + fourdigit;
			
			*(yattack + counter) = fourdigit2;
		/***               END OF EQUATION              ***/

		/***    Initializing the xhurtend array values ***/
			fourdigit2 = 0;
			bad_int = (ch = fgetc( stream ));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1000;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 100;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 10;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1;
			fourdigit2 = fourdigit2 + fourdigit;
			
			*(xhurtend + counter) = fourdigit2;
		/***               END OF EQUATION              ***/

		/***    Initializing the yhurtend array values ***/
			fourdigit2 = 0;
			bad_int = (ch = fgetc( stream ));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1000;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 100;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 10;
			fourdigit2 = fourdigit2 + fourdigit;

			bad_int = (ch = fgetc( stream));
			fourdigit = char_int(bad_int);
			fourdigit = fourdigit * 1;
			fourdigit2 = fourdigit2 + fourdigit;
			
			*(yhurtend + counter) = fourdigit2;
		/***               END OF EQUATION              ***/

			counter = counter +1;
		 }

	}


};

/***********************************************************************/
/****                    DEFINING A MAP CLASS                       ****/
/***********************************************************************/
class BGMAP
{
public:
	int tile[10][11];            // X and y points of the blocks
	BGMAP()                  // the class constructor
	{
		int counter = 0;
		int counter2 = 0;
		int twodigit = 0;
		int twodigit2 = 0;
		while(counter2 <= 10)
		{
			while(counter <= 9)
			{
			twodigit = 0;
			twodigit2 = 0;
			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 10;
			twodigit2 = twodigit2 + twodigit;

			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 1;
			twodigit2 = twodigit2 + twodigit;

			tile[counter][counter2] = twodigit2;
			counter = counter + 1;
			}
			counter = 0;
			counter2 = counter2 + 1;
		}
	}

};
/***********************************************************************/
/****             DEFINING A SCREEN CENTERING OBJECT                ****/
/***********************************************************************/
class CENTERSCREEN
{
public:
	int xpos;
	int ypos;

	CENTERSCREEN(int startx, int starty)
	{
		xpos = startx;
		ypos = starty;
	}
};
CENTERSCREEN center(100,100), center1(100,100),center2(100,100);
/*****************************************************************************/
class COLLIDE
{
public:
	int xstart[9];
	int ystart[9];
	int xend[9];
	int yend[9];
	int xhill[9];
	int yhill[9];
	int xup[9];
	int yup[9];
	int way[9];
	int thick[9];
	int length[9];
	COLLIDE()
	{
		int counter = 0;
		int twodigit = 0;
		int twodigit2 = 0;
		while(counter <= 8)
			{
			twodigit = 0;
			twodigit2 = 0;
	
			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 10;
			twodigit2 = twodigit2 + twodigit;

			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 1;
			twodigit2 = twodigit2 + twodigit;

			xstart[counter]= twodigit2;

			twodigit = 0;
			twodigit2 = 0;

			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 10;
			twodigit2 = twodigit2 + twodigit;

			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 1;
			twodigit2 = twodigit2 + twodigit;

			ystart[counter]= twodigit2;

			twodigit = 0;
			twodigit2 = 0;

			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 10;
			twodigit2 = twodigit2 + twodigit;

			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 1;
			twodigit2 = twodigit2 + twodigit;

			xend[counter]= twodigit2;

			twodigit = 0;
			twodigit2 = 0;

			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 10;
			twodigit2 = twodigit2 + twodigit;

			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 1;
			twodigit2 = twodigit2 + twodigit;

			yend[counter]= twodigit2;

			twodigit = 0;
			twodigit2 = 0;

			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 10;
			twodigit2 = twodigit2 + twodigit;

			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 1;
			twodigit2 = twodigit2 + twodigit;

			xhill[counter]= twodigit2;

			twodigit = 0;
			twodigit2 = 0;
			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 10;
			twodigit2 = twodigit2 + twodigit;

			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 1;
			twodigit2 = twodigit2 + twodigit;

			yhill[counter]= twodigit2;

			twodigit = 0;
			twodigit2 = 0;

			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 1;
			twodigit2 = twodigit2 + twodigit;

			xup[counter]= twodigit2;


			twodigit = 0;
			twodigit2 = 0;

			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 1;
			twodigit2 = twodigit2 + twodigit;

			yup[counter]= twodigit2;

			twodigit = 0;
			twodigit2 = 0;
			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 1;
			twodigit2 = twodigit2 + twodigit;
			thick[counter] = twodigit2;

			twodigit = 0;
			twodigit2 = 0;
			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 1;
			twodigit2 = twodigit2 + twodigit;
			way[counter] = twodigit2;


			twodigit = 0;
			twodigit2 = 0;
			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 10;
			twodigit2 = twodigit2 + twodigit;

			bad_int = (ch = fgetc( stream ));
			twodigit = char_int(bad_int);
			twodigit = twodigit * 1;
			twodigit2 = twodigit2 + twodigit;

			length[counter]= twodigit2;

			counter = counter + 1;
			}
		}
};

/*****************************************************************************/
void drawlayer(BGMAP MAP, CENTERSCREEN CENT,BITMAP *BMP)
{
		while(drawcounter2 < 3)
		{
			while(drawcounter < 5)
			{
				use1 = ((CENT.xpos / 100) + drawcounter);
				use2 = ((CENT.ypos / 100) + drawcounter2);
				use = MAP.tile[use1][use2];
				//if(use != 0)  // Speed hack, not sure if I'll use it yet.
				masked_blit(BMP, newscreen, use * 100,0,((use1  * 100) - CENT.xpos ),((use2 * 100) - CENT.ypos ),100,100);
				drawcounter = drawcounter + 1;

			}
			drawcounter = 0;
			drawcounter2 = drawcounter2 + 1;
		}
		drawcounter = 0;
		drawcounter2 = 0;
}
/*****************************************************************************/
int hill(int two, int three, COLLIDE COL, int one)
{
	int posneg = 1;
	int giveback = 0;
	if(COL.way[one] == 0)
		posneg = -1;
	if(COL.xup[one] != 0)
		giveback = (COL.yup[one] * (((((two  + three) - (((two + three) / 100) * 100)) - COL.xhill[one]) / COL.xup[one]) * posneg));
	return giveback;
}
/*****************************************************************************/
int coldetect(BGMAP MAP, CENTERSCREEN CENT, SPRITE PLAY, COLLIDE COL)
{
		use1 = (((PLAY.xpos + PLAY.lcxstart) / 100));
		use2 = (((PLAY.ypos + PLAY.lcyend) / 100));
		use = MAP.tile[use1][use2];
		int use3 = (((PLAY.xpos + PLAY.lcxend) / 100));
		int use4 = (((PLAY.ypos + PLAY.lcyend) / 100));
		int use5 = MAP.tile[use3][use4];
		if((((PLAY.ypos + PLAY.lcyend) - (((PLAY.ypos + PLAY.lcyend) / 100) * 100) ) >= COL.ystart[use] && ((PLAY.ypos + PLAY.lcyend) - (((PLAY.ypos + PLAY.lcyend) / 100) * 100) ) < COL.yend[use]))  
		{
			if(((((PLAY.xpos + PLAY.lcxstart) - (((PLAY.xpos + PLAY.lcxstart) / 100) * 100) ) >= COL.xstart[use] && ((PLAY.xpos + PLAY.lcxstart) - (((PLAY.xpos + PLAY.lcxstart) / 100) * 100)) <= COL.xend[use]))) 
				return 1;
			else
				return 0;
		}
		else
		{
			if((((PLAY.ypos + PLAY.lcyend) - (((PLAY.ypos + PLAY.lcyend) / 100) * 100) ) >= COL.ystart[use5] && ((PLAY.ypos + PLAY.lcyend) - (((PLAY.ypos + PLAY.lcyend) / 100) * 100) ) < COL.yend[use5]))  
			{
					if(((((PLAY.xpos  + PLAY.lcxend) - (((PLAY.xpos + PLAY.lcxend) / 100) * 100) ) >= COL.xstart[use5] && ((PLAY.xpos + PLAY.lcxend) - (((PLAY.xpos + PLAY.lcxend) / 100) * 100)) <= COL.xend[use5])) )
						return 2;
					else
						return 0;
			}
			else
			{
				if((((PLAY.ypos + PLAY.lcyend) - (((PLAY.ypos + PLAY.lcyend) / 100) * 100) ) >= (COL.yhill[use] + hill(PLAY.xpos,PLAY.lcxstart, COL, use)) && ((PLAY.ypos + PLAY.lcyend) - (((PLAY.ypos + PLAY.lcyend) / 100) * 100) ) < ((COL.yhill[use] + hill(PLAY.xpos,PLAY.lcxstart, COL, use) + COL.thick[use]))))
					return 3;
				else
				{
					if((((PLAY.ypos + PLAY.lcyend) - (((PLAY.ypos + PLAY.lcyend) / 100) * 100) ) >= (COL.yhill[use5] + hill(PLAY.xpos,PLAY.lcxend, COL, use5)) && ((PLAY.ypos + PLAY.lcyend) - (((PLAY.ypos + PLAY.lcyend) / 100) * 100) ) < ((COL.yhill[use5] + hill(PLAY.xpos,PLAY.lcxend, COL, use5) + COL.thick[use5]))))
						return 4;
					else
						return 0;
				}
			}
		}

} 
/*****************************************************************************/
int stick(BGMAP MAP, SPRITE PLAY, COLLIDE COL)
{
	int giveback = 0;
		use1 = (((PLAY.xpos + PLAY.lcxstart) / 100));
		use2 = (((PLAY.ypos + PLAY.lcyend) / 100));
		use = MAP.tile[use1][use2];
		int use3 = (((PLAY.xpos + PLAY.lcxend) / 100));
		int use4 = (((PLAY.ypos + PLAY.lcyend) / 100));
		int use5 = MAP.tile[use3][use4];
		if( PLAY.Dcol == 1)
		{
			while((((PLAY.ypos + PLAY.lcyend) - (((PLAY.ypos + PLAY.lcyend) / 100) * 100) ) + giveback < (COL.ystart[use]) + 2)  )
			{
				giveback = giveback + 1;
			}
			while((((PLAY.ypos + PLAY.lcyend) - (((PLAY.ypos + PLAY.lcyend) / 100) * 100) ) + giveback > (COL.ystart[use]) + 2)  )
			{
				giveback = giveback - 1;
			}

			return giveback;
		}
		if( PLAY.Dcol == 2)
		{
			while((((PLAY.ypos + PLAY.lcyend) - (((PLAY.ypos + PLAY.lcyend) / 100) * 100) ) + giveback < (COL.ystart[use5]) + 2)  )
			{
				giveback = giveback + 1;
			}
			while((((PLAY.ypos + PLAY.lcyend) - (((PLAY.ypos + PLAY.lcyend) / 100) * 100) ) + giveback > (COL.ystart[use5]) + 2)  )
			{
				giveback = giveback - 1;
			}
			return giveback;
		}
		if( PLAY.Dcol == 3)
		{
			while((((PLAY.ypos + PLAY.lcyend) - (((PLAY.ypos + PLAY.lcyend) / 100) * 100) ) + giveback < ((COL.yhill[use] + hill(PLAY.xpos,PLAY.lcxstart, COL, use)) + 2))  )
			{
				giveback = giveback + 1;
			}
			while((((PLAY.ypos + PLAY.lcyend) - (((PLAY.ypos + PLAY.lcyend) / 100) * 100) ) + giveback > ((COL.yhill[use] + hill(PLAY.xpos,PLAY.lcxstart, COL, use)) + 2) ) )
			{
				giveback = giveback - 1;
			}
			return giveback;
		}
		if( PLAY.Dcol == 4)
		{
			while((((PLAY.ypos + PLAY.lcyend) - (((PLAY.ypos + PLAY.lcyend) / 100) * 100) ) + giveback < ((COL.yhill[use5] + hill(PLAY.xpos,PLAY.lcxstart, COL, use5)) + 2) ) )
			{
				giveback = giveback + 1;
			}
			while((((PLAY.ypos + PLAY.lcyend) - (((PLAY.ypos + PLAY.lcyend) / 100) * 100) ) + giveback > ((COL.yhill[use5] + hill(PLAY.xpos,PLAY.lcxstart, COL, use5)) + 2) ) )
			{
				giveback = giveback - 1;
			}
			return giveback;
		}
		else
		{
			return 0;
		}
} 
/*****************************************************************************/
/*****************************************************************************/
/*****************************************************************************/
/*****************************************************************************/
/*****************************************************************************/
/*****************************************************************************/
/*****************************************************************************/
/*****************************************************************************/
/*****************************************************************************/

SPRITE player("sonic",200,200);
SPEED gravity(1,1,0,0,30);
SPEED left(1,2,0,0,20);
SPEED right(1,2,0,0,20);
int main()
{
/*********************************************************************/
/****           Intializing all of the allegro functions          ****/
/*********************************************************************/
	allegro_init();
	install_timer();
	install_keyboard();
	set_color_depth(16);
	set_gfx_mode(GFX_AUTODETECT,320,200,0,0);
	install_sound(DIGI_AUTODETECT,MIDI_AUTODETECT, " ");
	song = load_midi("level.mid");
/*********************************************************************/
/****    Setting the pointers to point to various data sources    ****/
/*********************************************************************/
	PALETTE pal;
	player.frames = load_bmp(player.bmp, pal);
	newscreen = load_bmp("splash.bmp", pal);
	temp = create_bitmap(100,100);
	bg1 = load_bmp("bg1.bmp", pal);
	bg2 = load_bmp("bg2.bmp", pal);
	bg3 = load_bmp("bg3.bmp", pal);
/*	bg4 = load_bmp("bg3.bmp", pal); */
/*********************************************************************/
/****         Loading the Map data files, very important          ****/
/*********************************************************************/

	stream = fopen("map1.mif", "r" );

	BGMAP map1;

	stream = fopen("map2.mif", "r" );

	BGMAP map2;	

	stream = fopen("map3.mif", "r" );

	BGMAP map3;
	
	stream = fopen("colmap.mif", "r" );
	COLLIDE blocks;

/*********************GAME LOOP***************************/
	play_midi(song, 1);
/*********************************************************************/
	while( 0 == 0)
	{
		drawcounter = 0;
		drawcounter2 = 0;
		if (key[KEY_SPACE])
			break;

player.Dcol = coldetect(map3,center, player,blocks); 
		if(player.Dcol != 0)
			player.ypos = player.ypos + stick(map3, player, blocks); 
/*******************************GRAVITY CODE*********************************/		
		if(player.Dcol == 0)
		{
			if(gravity.setspeed == 0)
				gravity.setspeed = gravity.setspeed + gravity.acceleration;

			gravity.acccount = gravity.acccount + 1;
			
			if(gravity.acccount >= 10)
			{
				gravity.acccount = 0;
				gravity.setspeed = gravity.setspeed + gravity.acceleration;
			}

			if(gravity.setspeed > gravity.topspeed)
			{
				gravity.setspeed = gravity.topspeed;
			}

			if(gravity.speed > gravity.topspeed)
			{
				gravity.speed = gravity.topspeed;
			}


			while(gravity.speed >= 10)
			{
				player.ypos = player.ypos + 1;
				gravity.speed = gravity.speed - 10;
			}


			gravity.speed = gravity.speed + gravity.setspeed;

		}
/*****************************END GRAVITY CODE*******************************/

		
/***************************RIGHT MOVEMENT CODE******************************/		
		if(player.Rcol == 0)
		{
			if(key[KEY_RIGHT])
			{
				if(right.setspeed == 0)
					right.setspeed = right.setspeed + right.acceleration;

				right.acccount = right.acccount + 1;
			
				if(right.acccount >= 10)
				{
					right.acccount = 0;
					right.setspeed = right.setspeed + right.acceleration;
				}
			}
			else
				if(right.speed > 0)
				{
					right.deccount = right.deccount + 1;
			
					if(right.deccount >= 10)
					{
						right.deccount = 0;
						right.setspeed = right.setspeed - right.decceleration;
					}
				}


			if(right.setspeed > right.topspeed)
			{
				right.setspeed = right.topspeed;
			}

			if(right.speed > right.topspeed)
			{
				right.speed = right.topspeed;
			}

			if(right.speed < 0)
			{
				right.speed = 0;
			}


			while(right.speed >= 10)
			{
				player.xpos = player.xpos + 1;
				right.speed = right.speed - 10;
			}


			right.speed = right.speed + right.setspeed;

		}
/*************************END RIGHT MOVEMENT CODE****************************/
		

		
/***************************LEFT MOVEMENT CODE******************************/		
		if(player.Lcol == 0)
		{
			if(key[KEY_LEFT])
			{
				if(left.setspeed == 0)
					left.setspeed = left.setspeed + left.acceleration;

				left.acccount = left.acccount + 1;
			
				if(left.acccount >= 10)
				{
					left.acccount = 0;
					left.setspeed = left.setspeed + left.acceleration;
				}
			}
			else
				if(left.speed > 0)
				{
					left.deccount = left.deccount + 1;
			
					if(left.deccount >= 10)
					{
						left.deccount = 0;
						left.setspeed = left.setspeed - left.decceleration;
					}
				}


			if(left.setspeed > left.topspeed)
			{
				left.setspeed = left.topspeed;
			}

			if(left.speed > left.topspeed)
			{
				left.speed = left.topspeed;
			}

			if(left.speed < 0)
			{
				left.speed = 0;
			}
			while(left.speed >= 10)
			{
				player.xpos = player.xpos - 1;
				left.speed = left.speed - 10;
			}


			left.speed = left.speed + left.setspeed;

		}
/*************************END LEFT MOVEMENT CODE****************************/

		if(player.ypos > 100)
			center.ypos = player.ypos - 100;
		if(player.xpos > 160)
			center.xpos = player.xpos - 160;
drawlayer(map1,center,bg1);
drawlayer(map3,center,bg3);
masked_blit(player.frames , newscreen, *(player.picxstart), *(player.picystart), player.xpos - center.xpos, player.ypos - center.ypos, *(player.picxend) , *(player.picyend));

				//vsync();         // Vertical Synchronization.
				blit(newscreen, screen, 0, 0 , 0, 0, 320, 200);

	}

/*********************************************************************/

	readkey();

	blit(newscreen, screen, 0, 0, 0, 0, 320, 200);
	readkey();


	readkey();

	return 0;
}
END_OF_MAIN();
